from p3dsdk import ui
import pathlib
import os


default_csv_path = os.path.join(os.path.dirname(__file__), "ral_standard.csv")
lumiscaphe_folder = r"C:\Program Files\Lumiscaphe"
last_installed_p3d_name = [x for x in os.listdir(lumiscaphe_folder) if x.startswith("Patchwork 3D 20")][-1]
last_installed_p3d_folder = os.path.join(lumiscaphe_folder, last_installed_p3d_name)
library_folder = os.path.join(last_installed_p3d_folder, "library", "Materials")
desktop_folder = os.path.expanduser("~/Desktop")


class ScriptRalUi(ui.Window):
    def __init__(self):
        super().__init__(name="RAL Ui")   
        self.form = ui.Forms(name="Générer une librairie de matériaux", ok=True, cancel=True, width=600, height=200)

        self.form.start_group("Entrées")
        self.form.add_open_file_selector(name="path_csv_file", label="Fichier csv :", filter="File csv (*.csv)", filename=default_csv_path)
        self.form.add_open_folder_selector(name="path_lib_kmt", label="Bibliothèque de matériaux :", dir=last_installed_p3d_folder)
        self.form.end_group()

        self.form.start_group("Sortie")
        self.form.add_open_folder_selector(name="path_folder_dest", label="Enregistrer la librairie sous :", dir=desktop_folder)
        self.form.end_group()

    def show(self) -> bool:
        return self.form.show()

    def path_csv_file(self) -> str:
        return self.form.values["path_csv_file"]

    def path_lib_kmt(self) -> str:
        return self.form.values["path_lib_kmt"]

    def path_folder_dest(self) -> str:
        return self.form.values["path_folder_dest"]


class ScriptRalUiNoOutput(ui.Window):
    def __init__(self):
        super().__init__(name="RAL Ui")   
        self.form = ui.Forms(name="Générer une librairie de matériaux", ok=True, cancel=True, width=600, height=200)

        self.form.start_group("Entrées")
        self.form.add_open_file_selector(name="path_csv_file", label="Fichier csv :", filter="File csv (*.csv)", filename=default_csv_path)
        self.form.add_open_folder_selector(name="path_lib_kmt", label="Bibliothèque de matériaux :", dir=last_installed_p3d_folder)
        self.form.end_group()

    def show(self) -> bool:
        return self.form.show()

    def path_csv_file(self) -> str:
        return self.form.values["path_csv_file"]

    def path_lib_kmt(self) -> str:
        return self.form.values["path_lib_kmt"]


class ScriptRalUiError(ui.Window):
    def __init__(self):
        super().__init__(name="RAL Ui error")
        self.form = ui.Forms(name="Générer une librairie de matériaux", ok=True, cancel=True, width=700, height=50)

    def show(self) -> bool:
        return self.form.show()

    def add_text(self, text):
        self.form.add_text(text)
